package me.mctp.commands;

import me.mctp.Main;
import me.mctp.api.AudioType;
import me.mctp.api.HueType;
import me.mctp.managers.PinManager;
import me.mctp.utils.HeadUtil;
import me.mctp.utils.SpigotPlayerSelector;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.json.simple.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class MCTPAudioCMD implements CommandExecutor {

    public static String prefix = (ChatColor.GOLD + "[" + ChatColor.YELLOW + "MCTP" + ChatColor.GOLD + "] " + ChatColor.GRAY);

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String commandlabel, String[] args) {
        if (cmd.getName().equalsIgnoreCase("mctpaudio")) {
            if (!sender.hasPermission("mctp.audio")) {
                sender.sendMessage(prefix + "You don't have the permission to do this.");
                return true;
            }

            if (args.length == 1 && args[0].equalsIgnoreCase("toggleradio")) {
                if (Main.getPlaylist().isRunning()) {
                    Main.getPlaylist().stop();
                    sender.sendMessage(prefix + "De auto radio is stopgezet. Zodra het huidige nummer is afgelopen, gebeurt er niks meer.");
                } else {
                    Main.getPlaylist().init();
                    sender.sendMessage(prefix + "De auto radio is weer gestart.");
                }
                return true;
            } else if (args.length == 2 && args[0].equalsIgnoreCase("addsong")) {
                List<String> urls = Main.getPlugin().getConfig().getStringList("RadioSongs");
                urls.add(args[1]);
                Main.getPlugin().getConfig().set("RadioSongs", urls);
                Main.getPlugin().saveConfig();
                Main.getPlaylist().addSong(args[1]);
                sender.sendMessage(prefix + "Nummer toegevoegd aan de lijst.");
                return true;
            } else if (args.length == 4 && args[0].equalsIgnoreCase("play")) {
                AudioType type;
                try {
                    type = AudioType.valueOf(args[2].toUpperCase());
                } catch (IllegalArgumentException ex) {
                    sender.sendMessage(prefix + args[2] + " is geen correcte type.");
                    return true;
                }

                ArrayList<Player> players = new ArrayList<>();
                Player target = Bukkit.getPlayer(args[1]);
                if (target != null) {
                    if (!PinManager.hasPin(target.getUniqueId())) {
                        sender.sendMessage(prefix + "Die speler is niet verbonden met de client.");
                        return true;
                    }

                    players.add(target);
                } else {
                    SpigotPlayerSelector selector = new SpigotPlayerSelector(args[1]);
                    players.addAll(selector.getPlayers(sender));
                }

                JSONObject data;
                for (Player p : players) {
                    data = new JSONObject();

                    if (!PinManager.hasPin(p.getUniqueId())) continue;

                    data.put("task", type.name());
                    data.put("path", args[3]);
                    data.put("uuid", p.getUniqueId().toString().replace("-", ""));
                    Main.getClient().sendData(data);
                }

                sender.sendMessage(prefix + "Gestart met afspelen!");
                return true;
            } else if ((args.length == 6 || args.length == 7) && args[0].equalsIgnoreCase("hue")) {
                int r;
                int g;
                int b;
                try {
                    r = Integer.parseInt(args[2]);
                    g = Integer.parseInt(args[3]);
                    b = Integer.parseInt(args[4]);
                } catch (IllegalArgumentException ex) {
                    sender.sendMessage(prefix + args[2] + ", " + args[3] + ", " + args[4] + " zijn incorrecte RGB waardes.");
                    return true;
                }

                Integer brightness = null;
                if (args.length == 7) {
                    try {
                        brightness = Integer.parseInt(args[6]);
                    } catch (IllegalArgumentException ex) {
                        sender.sendMessage(prefix + args[6] + " is geen correcte brightness.");
                        return true;
                    }

                    if (brightness < 0 || brightness > 254) {
                        sender.sendMessage(prefix + args[6] + " is geen correcte brightness.");
                        return true;
                    }
                }

                HueType type;
                try {
                    type = HueType.valueOf(args[5].toUpperCase());
                } catch (IllegalArgumentException ex) {
                    sender.sendMessage(prefix + args[5] + " is geen correcte type.");
                    return true;
                }

                ArrayList<Player> players = new ArrayList<>();
                Player target = Bukkit.getPlayer(args[1]);
                if (target != null) {
                    if (!PinManager.hasPin(target.getUniqueId())) {
                        sender.sendMessage(prefix + "Die speler is niet verbonden met de client.");
                        return true;
                    }

                    players.add(target);
                } else {
                    SpigotPlayerSelector selector = new SpigotPlayerSelector(args[1]);
                    players.addAll(selector.getPlayers(sender));
                }

                //CHECK FOR THE REGION SELECTOR -> Then save
                if (args[1].startsWith("@a") && HeadUtil.getArgument(args[1], "region").length() != 0) {
                    String regionID = HeadUtil.getArgument(args[1], "region");
                    String data = r + "_" + g + "_" + b + "_" + type.name();
                    if (brightness != null) data += "_" + brightness;

                    Main.getPlugin().getConfig().set("HueRegions." + regionID, data);
                    Main.getPlugin().saveConfig();
                }

                JSONObject data;
                for (Player p : players) {
                    data = new JSONObject();

                    if (!PinManager.hasPin(p.getUniqueId())) continue;

                    data.put("task", "HUE");
                    data.put("rgb", r + ":" + g + ":" + b);
                    data.put("type", type.name());
                    if (brightness != null) data.put("brightness", brightness);
                    data.put("uuid", p.getUniqueId().toString().replace("-", ""));
                    Main.getClient().sendData(data);
                }

                sender.sendMessage(prefix + "Indien de speler(s) is/zijn verbonden met Philips Hue, is de kleur veranderd.");
                return true;
            } else if (args.length == 3 && args[0].equalsIgnoreCase("setregion")) {
                String regionName = args[1];
                String url = args[2];

                Main.getPlugin().getConfig().set("Regions." + regionName, url);
                Main.getPlugin().saveConfig();

                sender.sendMessage(prefix + "De region zal vanaf nu muziek afspelen.");
                return true;
            } else if (args.length == 3 && args[0].equalsIgnoreCase("sethueregion")) {
                String regionName = args[1];
                String url = args[2];

                Main.getPlugin().getConfig().set("Regions." + regionName, url);
                Main.getPlugin().saveConfig();

                sender.sendMessage(prefix + "De region zal vanaf nu muziek afspelen.");
                return true;
            } else if (args.length == 2 && args[0].equalsIgnoreCase("stop")) {
                ArrayList<Player> players = new ArrayList<>();
                Player target = Bukkit.getPlayer(args[1]);
                if (target != null) {
                    if (!PinManager.hasPin(target.getUniqueId())) {
                        sender.sendMessage(prefix + "Die speler is niet verbonden met de client.");
                        return true;
                    }

                    players.add(target);
                } else {
                    SpigotPlayerSelector selector = new SpigotPlayerSelector(args[1]);
                    players.addAll(selector.getPlayers(sender));
                }

                JSONObject data;
                for (Player p : players) {
                    data = new JSONObject();

                    if (!PinManager.hasPin(p.getUniqueId())) continue;

                    data.put("task", "STOP");
                    data.put("uuid", p.getUniqueId().toString().replace("-", ""));
                    Main.getClient().sendData(data);
                }

                sender.sendMessage(prefix + "Gestopt met afspelen!");
                return true;
            }
        } else if (cmd.getName().equalsIgnoreCase("audio")) {
            if (!(sender instanceof Player)) {
                sender.sendMessage(prefix + "Alleen spelers kunnen verbinden met onze audioclient.");
                return true;
            }

            Player p = (Player) sender;
            String pin = PinManager.getPIN(p.getUniqueId());

            String url = "http://audio.mcthemeparks.eu/";
            url = url + "?uuid=" + p.getUniqueId().toString().replace("-", "") + "&pin=" + pin;

            TextComponent message = new TextComponent(TextComponent.fromLegacyText(prefix + "Click here to connect to the audio client."));
            message.setClickEvent(new ClickEvent(ClickEvent.Action.OPEN_URL, url));
            p.spigot().sendMessage(message);
            return true;
        }
        return false;
    }

}
