package me.mctp.listener;

import com.sk89q.worldguard.protection.regions.ProtectedRegion;
import me.mctp.Main;
import me.mctp.managers.PinManager;
import me.mctp.managers.WGManager;
import net.raidstone.wgevents.events.RegionsEnteredEvent;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.json.simple.JSONObject;

import java.util.*;
import java.util.stream.Collectors;

public class WGListener implements Listener {
    /** Music detection */
    @EventHandler
    public void onMove(PlayerMoveEvent e) {
        if (e.getTo() == null || e.getFrom().getWorld() == null || e.getTo().getWorld() == null) return;

        if (e.getFrom().getBlockX() != e.getTo().getBlockX() || e.getFrom().getBlockY() != e.getTo().getBlockY() || e.getFrom().getBlockZ() != e.getTo().getBlockZ()) {
            Set<String> list = Main.getPlugin().getConfig().getConfigurationSection("Regions").getKeys(false);

            if (!PinManager.hasPin(Objects.requireNonNull(e.getPlayer()).getUniqueId())) return;

            List<ProtectedRegion> regions = WGManager.getRegionsIn(e.getFrom());
            List<String> regionNames = regions.stream().map(ProtectedRegion::getId).collect(Collectors.toList());
            List<ProtectedRegion> regions2 = WGManager.getRegionsIn(e.getTo());
            List<String> regionNames2 = regions2.stream().map(ProtectedRegion::getId).collect(Collectors.toList());

            if ((Collections.disjoint(list, regionNames) && !Collections.disjoint(list, regionNames2)) || (!Collections.disjoint(list, regionNames) && !Collections.disjoint(list, regionNames2))) {
                //Walked in a region

                if (!Collections.disjoint(list, regionNames) && !Collections.disjoint(list, regionNames2)) {
                    Optional<String> name = regionNames.stream().filter(list::contains).findFirst();
                    Optional<String> name2 = regionNames2.stream().filter(list::contains).findFirst();
                    if (name.isPresent() && name2.isPresent() && name.get().equals(name2.get())) {
                        return;
                    }

                    if (name.isPresent() && name2.isPresent()) {
                        String regionURL = Main.getPlugin().getConfig().getString("Regions." + name.get());
                        String regionURL2 = Main.getPlugin().getConfig().getString("Regions." + name2.get());

                        if (regionURL.equals(regionURL2)) {
                            return;
                        }
                    }
                }

                Optional<String> name = regionNames2.stream().filter(list::contains).findFirst();
                if (!name.isPresent()) return;
                String regionURL = Main.getPlugin().getConfig().getString("Regions." + name.get());

                JSONObject data = new JSONObject();
                data.put("task", "MUSIC");
                data.put("path", regionURL);
                data.put("uuid", e.getPlayer().getUniqueId().toString().replace("-", ""));
                Main.getClient().sendData(data);
            } else if (!Collections.disjoint(list, regionNames) && Collections.disjoint(list, regionNames2)) {
                //Not in a region, stop...
                JSONObject data = new JSONObject();
                data.put("task", "MUSIC");
                data.put("path", "");
                data.put("uuid", e.getPlayer().getUniqueId().toString().replace("-", ""));
                Main.getClient().sendData(data);
            }
        }
    }

    /** Hue detection */
    @EventHandler
    public void onRegionEnter(RegionsEnteredEvent e) {
        if (e.getPlayer() == null) return;

        Set<String> list2 = Main.getPlugin().getConfig().getConfigurationSection("HueRegions").getKeys(false);

        if (!Collections.disjoint(list2, e.getRegionsNames())) {
            //One element is the same -> In a region

            Optional<String> name = e.getRegionsNames().stream().filter(list2::contains).findFirst();
            if (!name.isPresent()) return;
            String configData = Main.getPlugin().getConfig().getString("HueRegions." + name.get());

            if (configData == null) return;
            String[] configDataSplit = configData.split("_");

            int r = Integer.parseInt(configDataSplit[0]);
            int g = Integer.parseInt(configDataSplit[1]);
            int b = Integer.parseInt(configDataSplit[2]);
            String type = configDataSplit[3];
            Integer brightness = null;
            if (configDataSplit.length == 5) brightness = Integer.parseInt(configDataSplit[4]);

            if (!PinManager.hasPin(e.getPlayer().getUniqueId())) return;

            JSONObject data = new JSONObject();
            data.put("task", "HUE");
            data.put("rgb", r + ":" + g + ":" + b);
            data.put("type", type);
            if (brightness != null) data.put("brightness", brightness);
            data.put("uuid", e.getPlayer().getUniqueId().toString().replace("-", ""));
            Main.getClient().sendData(data);
        }
    }
}
